.include	GPL951_Body.inc


.public _RESET
.public _CS0Boot

.ram_bank0
.VAR _CS0Boot
.external __sn_init_table, _main, __sn_sp_val
.external	_MoveCodeToRAM
//GPL951HW_Reset: .section .text, .addr=0x8FFF
//    .DW 0x8000 
.code
unSP_StartUp: .section .text, .addr=0x9040
//unSP_StartUp: .section .text, .addr=0x9000
StartUp:
_RESET:
  	int off
//	sp = __sn_sp_val
//	call _MoveCodeToRAM
//	r3 = 0x100
//	r4 = 0
//	call mr
//	r1 = 1
//	[_CS0Boot] = r1
L_SYS_Register_Setting:
//P_BodyID:                       	.VDEF   P_System_Ctrl_Base+0x00
//P_System_Ctrl:					.VDEF   P_System_Ctrl_Base+0x03
	r1 = C_UEXCE_INT_Dis + C_Halt_Wakeup_Reset + C_CLK32K_External + 0x8000
	[P_SYS_Ctrl] = r1
//P_CLK_Ctrl0:						.VDEF   P_System_Ctrl_Base+0x04
//P_CLK_Ctrl1:						.VDEF   P_System_Ctrl_Base+0x05
	r1 = 0xffff
	[P_CLK_Ctrl0] = r1
	[P_CLK_Ctrl0] = r1
//P_Reset_Flag:                   	.VDEF   P_System_Ctrl_Base+0x06
//P_Clock_Ctrl:                   	.VDEF   P_System_Ctrl_Base+0x07
	r1 = [P_Clock_Ctrl]
	r1 &= 0xfff0
	r1 |= 0x0008
	[P_Clock_Ctrl] = r1
//P_LVR_Ctrl:                     	.VDEF   P_System_Ctrl_Base+0x08
//P_WatchDog_Ctrl:                	.VDEF   P_System_Ctrl_Base+0x0A
	r1 = C_WatchDog_Dis
	[P_WatchDog_Ctrl] = r1
	goto Initial
	
//	.include  Dummy_FF.asm


Initial:
///////////////////////////////		//global variable initial value setup
	ds = seg __sn_init_table
	r1 = offset __sn_init_table
	r2 = ds:[r1++]		// item count
	jmp __judge_itcount

__next_item:
	    push sr to [sp]
        push r2 to [sp]
        r3 = DS:[r1++]      // DS of iram
        r4 = DS:[r1++]      // dest
        r2 = DS:[r1++]      // DS
        r5 = DS:[r1++]      // src
        push r1 to [sp]
        r1 = DS:[r1]        // block size

        cmp r1, 0
        je __move_ok

		ds=r2				//Initial DS of src
__move_data:
        r2 = DS:[r5++]
        push sr to [sp]     // store DS of src
  		ds=r3
        DS:[r4++] = r2
		r3=ds
        r1 = r1 - 1
        pop sr from [sp]    // restore DS of src
__judge_bksize:
        cmp r1, 0
        jne __move_data

__move_ok:
        pop r1 from [sp]
        r1 = r1 + 1

        pop r2 from [sp]
        pop sr from [sp]
        r2 = r2 - 1
__judge_itcount:
        cmp r2,0
        jne __next_item
__no_item:
	call _main
__sn_loop2:
	jmp __sn_loop2
	nop
	nop

__sn_loop: 
	reti
///////////////////////////////	


//__DataReset:
////        sp = __sn_sp_val     ;
//        r1 = HIGH6 __sn_init_table ;
//      	sr &= 0x3FF
//        sr |= r1
//        r1 = offset __sn_init_table
//        r2 = D:[r1++]          // item count
//        jmp __judge_itcount  ;
//__next_item:
//        push r2,r2 to [sp] ;
//        r3 = D:[r1++]        // dest
//        r4 = D:[r1++]        // DS
//        r2 = D:[r1++]        // src
//        r5 = D:[r1++]        // block size
//
//		push sr, sr to [sp]
//		r4 = r4 lsl 4
//		r4 = r4 lsl 4
//		r4 = r4 lsl 2
//		sr &= 0x3FF
//		sr |= r4
//        jmp __judge_bksize 
//__move_data:   
//		r4 = DS:[r2++] 
//        [r3++] = r4        
//        r5 = r5 - 1        
//__judge_bksize:     
//        cmp r5,0           
//        jne __move_data     
//        pop sr, sr from [sp]
//        pop r2,r2 from [sp] 
//        r2 = r2 - 1         
//__judge_itcount:                
//        cmp r2,0            
//        jne __next_item      
//__no_item:
//		r1 = 0x01			//AP test
//		[0x001a] = r1		//AP test
//        goto _main
//        retf
//__sn_loop2:
//        jmp __sn_loop2      
//        nop
//        nop	
//		goto _main
//		retf
// 
// 


.DEBUG
    .DW '.stabs "startup_code.",0x3c,0,0,0',0x0d,0x0a
.DEBUG
    .DW '.stabs "__sn_main:F15",36,0,0,', 0, 0
    .DW offset _main,seg _main
    .DW 0x0d,0x0a
.DEBUG
    .DW '.stabs "__sn_end:F15",36,0,0,', 0, 0
    .DW offset __sn_loop2,seg __sn_loop2
    .DW 0x0d,0x0a
.DEBUG
    .DW '.stabs "__sn_exception:F15",36,0,0,', 0, 0
    .DW offset __sn_loop,seg __sn_loop
    .DW 0x0d,0x0a

.END


//--------------------------------------end of startup_Data.asm----------------------------------------






